\input Head

\section{\tt RectangularWindow}

A class representing a rectangular window.

\subsection{Description}

{\tt RectangularWindow} is a class representing a rectangular window, 
which can be used for low-pass filtering and spectral density estimation.
{\tt RectangularWindow} derives from the abstract base class {\tt Window}.

The sample values $w[i]$ of a rectangular window are:
%
\[
w[i]:=
\left\{
\begin{array}{ll}
1
& \quad 0\le i< N\ ,\\
0
& \quad {\rm otherwise}\ ,
\end{array}
\right.
\]
%
where $N$ is the length of the window.
A rectangular window is thus trivial, with an {\tt apply} method 
given by the  identity transformation.
A rectangular window is called a {\tt boxcar} window in 
Matlab \cite{RWmatlab}.

{\tt RectangularWindow} inherits its functionality from the 
abstract base class {\tt Window}.
See {\tt Window} for more details.

\subsection{Operating Instructions}

\subsubsection{Example Usage}

{\footnotesize
\begin{verbatim}

  // verify that a rectangular window is just the identity 
  // transformation when applied to input data
  
  float data[] = { -1.4, 6, 2.98, 4.3, 0.013 };  // arbitrary data

  Sequence<float> in(data,5);  // input sequence 
  Sequence<float> out;         // output sequence

  RectangularWindow rw; // Rectangular window

  // apply the window to the input data
  rw.apply(out, in);

  // test that output of the apply method equals the input
  //
  bool pass = true;
  for (size_t i = 0; i < in.size(); i++)
  {
      if (out[i] != in[i])
      {
          pass = pass && false;
      }
  }

  // display pass or fail on standard output
  //
  if (pass) 
  {  
      cout << "PASS: rectangular window test" << endl;
  }
  else
  {
      cout << "FAIL: rectangular window test" << endl;
  }

\end{verbatim}}

\subsection{Algorithms}

Not applicable.

\subsection{Accuracy}

Since the {\tt apply} method of a rectangular window is the identity
transformation, a rectangular window has infinite precision.

\subsection{Performance}

See {\tt Window}.

\subsection{Testing}

Even though {\tt RectangularWindow} is a trivial window,
it is tested (along with all the other windows) by the code 
contained in {\tt tWindow.cc}.
The following tests are performed:
%
\begin{itemize}
\item
test that proper exceptions are thrown by the rectangular window 
{\tt apply} and {\tt operator()} methods.
\item
test that the mean, rms, and rectangular window values are correct 
for trivial and non-trivial window lengths.
\item 
test that the output values are correct when a rectangular window is 
applied to non-trivial real and complex input sequences.
\end{itemize}
%
{\tt RectangularWindow} passes all of the above tests.

\subsection{Notes}

None.

\subsection{See Also}

\begin{itemize}
\item 
class {\tt Window}
\item
class {\tt WindowInfo}
\item
class {\tt HannWindow}
\item
class {\tt KaiserWindow}
\end{itemize}

\begin{thebibliography}{99}

\bibitem{RWmatlab} 
The MathWorks: {\tt http:\slash\slash www.mathworks.com}.

\end{thebibliography}

\input Tail

